/* extmain.skel include file for extraction
 * $Log: extmain.skel,v $
 * Revision 1.19  1999/11/18 19:30:33  nort
 * Added <math.h> for floor() as generated for conversions
 *
 * Revision 1.18  1995/10/18  02:05:48  nort
 * Changes to nlcon_display()
 *
 * Revision 1.17  1995/10/06  16:40:02  nort
 * Changes to nlcon_disp()
 * Old change to ROWS() and FRACSECS() macros
 *
 * Revision 1.16  1994/08/29  20:29:28  nort
 * Changes for OUI
 *
 * Revision 1.15  1993/09/27  18:55:31  nort
 * Cleaned up RCS log
 * Cleaned up rcsid[] with Watcom pragmas
 * Added #include <string.h> for memcpy prototype.
 *
 * Revision 1.14  1993/05/19  19:04:51  nort
 * Changed OPT_CON_INIT to OPT_CONSOLE_INIT to allow judicious
 * redefinition for TMA.
 */
#include <stdio.h>
#include <string.h>
#include <sys/kernel.h>
#include <unistd.h>
#include <math.h>
#include "oui.h"
#include "dbr.h"
#include "globmsg.h"
#include "msg.h"
#pragma off (unreferenced)
  static char emrcsid[] =
	"$Id: extmain.skel,v 1.19 1999/11/18 19:30:33 nort Exp nort $";
#pragma on (unreferenced)



 typedef unsigned short UINT;


 typedef unsigned char UCHAR;
	unsigned short InjectingInc = 0;


 typedef unsigned long ULONG;
ULONG CHROMtime;
#include "convfunc.h"
#include "ttdriver.h"
#include "defcals.h"

int tt_p4=72;
int tt_p3=48;
int tt_p2=24;
int tt_p1=0;




	
	

	 typedef float adT;
	 typedef float adT_flow;
	 typedef float vdc_chan;
	 typedef float vdc_pow;
	 typedef float adT_pump;

	 typedef float dacMSpr;

	 typedef UINT InjStateT;

float read_atod(int atod_chan) {
	
	unsigned short atod_val;
	float voltage = -99999;

	atod_val = tt_read_atod( atod_chan );
	atod_val = atod_val + 2048;
	atod_val = atod_val & 0xFFF;

	if (atod_val >= 2048)	{
		atod_val = atod_val|(0xF000);
		atod_val=~atod_val;
		++atod_val;
		voltage = -10.0 * ((float) atod_val) / 2048.0;
		//	printf("reading atod channel %i value is negative %i \n",atod_chan, atod_val);
	} else 	{
		voltage = 10.0 * ((float) atod_val) / 2048.0;
	//	printf("reading atod channel %i value is %f \n",atod_chan,voltage);

	}	

	return voltage;
}


float read_temp(int address) { 
	float voltage;

	voltage = read_atod(address);

	return convert_temps(voltage);
}


float read_temp12v(int address) { 
	float voltage;

	voltage = read_atod(address);

	return convert_temps12v(voltage);
}

float read_ad_value(int address, float R1, float V1, float V0) { 
	float Vx;

	Vx = read_atod(address);

	if (Vx < 0)
		Vx = -Vx;

	return convert_VtoR( Vx, R1, V1, V0 );

}



#include "valves.h"
#include "address.h"





	 typedef unsigned char DigOutWd;
	 typedef DigOutWd DigInWd;



	 typedef short DigBit;
	 typedef DigBit Bit_HI_LO;
	 typedef DigBit Bit_Op_Cl;
	 typedef DigBit Bit_Cl_Op;
	 typedef DigBit Bit_On_Off;
	 typedef DigBit Bit_Off_On;
	 typedef DigBit Bit_Air_Cal;
	 typedef DigBit Bit_offline;


	UCHAR MSDstateS;

int read_dig_in (unsigned short dig_chan)  {
	
	unsigned short dig_val;
	unsigned short address;
	int value;

	address=dig_chan/8;	
	dig_val=tt_read_digital(address);
	address=dig_chan-address*8;
	value=1<<address;
	//	address=pow(2,address);
	dig_val=dig_val&value;
	if (dig_val==0)
		return 0;
	return 1;
}

int read_dig_out(int chan) {

	return read_dig_in(chan+64);
}


int fail_board(int digch) {
	static int fail_toggle = 0;
	
	if (fail_toggle==0) {
		tt_scdc_command(100 + digch);
		fail_toggle = 1;
		return fail_toggle;
	}

	fail_toggle = 0;
	tt_scdc_command(digch);
	return fail_toggle;
}

// used to pulse a digch (hard coded for dig 20 and 21
// and MSDstate 4 and 5).
int trapToggle( int digch ) {
	static int pulse1 = 0;
	static int pulse2 = 0;
	int	pulse, state;
	const int trap1add = 20;
	const int trap2add = 21;

	if (digch == trap1add) {
	 	state = 4;
		pulse = pulse1;
	} else if (digch == trap2add) {
		state = 5;
		pulse = pulse2;
	} else {
		return 0;
	}

	// toggle dig line
	if ( MSDstateS == state ) {
		switch ( pulse ) {
			case 0:		// off, turn on
				tt_scdc_command( 100 + digch );
				pulse = 1;
				break;
			case 1:		// on, turn off
				tt_scdc_command( digch );
				pulse = 0;
				break;
		}
	} else {
		if ( pulse == 1 ) {
			tt_scdc_command( digch );
			pulse = 0;
		}
	}

	if (digch == trap1add)
		pulse1 = pulse;
	else
		pulse2 = pulse;

	return read_dig_out( digch );

}


#include <sys/types.h>
pid_t rs485_proxy;
short Omega485[34];

short OmegaArray( int add ) {
	return Omega485[add];
}



 typedef short OmegaT;

 typedef short OmegaTsp;
#include <math.h>
#include <sys/name.h>
#include <sys/kernel.h>
#include <sys/types.h>
#include <stdlib.h>
#include "/home/panther/drivers/smart/smart.h"
#include "regnames.h"
#include "panthermsg.h"

#define 		ECDOFFLINE 		-9999
#define			NUMSECSXAXIS	 150
#define			ELECRATE		0.1			// seconds

pid_t			ECDresp_proxy;

chrom_packet 	ECDresp[MAXDET];

long int 		DetAvgCt1=0, DetAvgCt2=0, DetAvgCt3=0, DetAvgCt4=0,
		 		DetAvgOffline1=0, DetAvgOffline2=0, DetAvgOffline3=0, DetAvgOffline4=0,
	 			ecd_sum1=0, ecd_sum2=0, ecd_sum3=0, ecd_sum4=0,
				ecdA_SF6save=0, ecdA_F11save=0, ecdA_COsave=0, ecdA_PANsave=0;
float			ecdSF6x = 0.0, ecdF11x = 0.0, ecdCOx = 0.0, ecdPANx = 0.0;
int				currPoint[MAXDET];

// function gets the data from shared data array with smart driver
long int GC_Ctr_Pull( int elecADD ) {
	long ecdDATA;
	
	if ( currPoint[elecADD] >= MAXPOINTS ) currPoint[elecADD] = 0;

	// new data
	if ( currPoint[elecADD] < ECDresp[elecADD].numpnts ) {
		ecdDATA = ECDresp[elecADD].resp[currPoint[elecADD]];
		currPoint[elecADD]++;
	} 
	else {
		ecdDATA = ECDOFFLINE;
		currPoint[elecADD] = 0;
		ECDresp[elecADD].numpnts = -1;
	}

	return ecdDATA;	
}




 typedef long GC_Freq;
 typedef long GC_Ctr;

GC_Freq ecdA_SF6, ecdA_F11, ecdA_CO, ecdA_PAN;

 typedef unsigned char UNYBL;


 typedef unsigned long InjFile;

InjFile ITXFileNum;




ULONG CUMSEC;
#include <sys/types.h>
pid_t valco_proxy;
int valvePos[10] = {0,0,3,3,3,3,3,3,3,3};


 typedef short valvT;
 typedef DigBit valvetext;
 typedef DigBit valveMS1text;
 typedef DigBit valveMS2text;
#include <math.h>
#include <sys/name.h>
#include <sys/kernel.h>
#include <sys/types.h>
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include "da_cache.h"
#include "regnames.h"

#define MAXMSDCHANS 	  8		// Max number of MS channels
#define MAXMSDIONS 		 30		// Max number of ions per channel
#define MAXMSDPOINTS 	 30		// Max Number of data points in a second for an ion
#define MSDOFFLINE 	  -9999
#define MSDMISSING	   -999
#define MAXSENDMSG     2000		// max number of chars from the msd server
#define SEPCHARS		":,()"
#define MSDIONFILE		"/home/panther/flight/msd.ions"

pid_t		MSDresp_proxy;

long int 	MSD_Data_Array[MAXMSDCHANS][MAXMSDPOINTS],
			MSD_Time_Array[MAXMSDPOINTS],
			msdTIMEoldPlot,
			MSchanAvg[MAXMSDCHANS],
			msd_sum[MAXMSDCHANS],
			MSD_ChanX;

unsigned int 	currMSDPoint[MAXMSDCHANS],
				chanInc;

unsigned char 	MSDresp[MAXSENDMSG];		// data returned by msd

struct MSwindow {
	float	ion;			// ion number
	float	dwell;			// dwell time (0 < dwell <= 1) (fraction of a second)
} MStable[MAXMSDCHANS][MAXMSDIONS];


int ReadMSDionFile ( char *IONFILE ) {
	FILE 	*fp;
	char 	buffer[1000];
	char 	*p;
	char	tmp[1];
	int		chan, inc;
	static char	once;
	double	ion, dwell;

	if (once == 1) return 0;

	fp = fopen(	IONFILE, "r" );
	if (fp == NULL) {
		fprintf(stderr, "Open failed: Cannont find %s\n", IONFILE);
		return -1;
	} else {
		while ( fgets( buffer, 1000, fp ) != NULL ) {

			// First strip out the MS channel number
			p = strstr( strlwr(buffer), "mschan" );
			strncpy(tmp, p + strlen("MSchan"), 1);
			chan = atoi(tmp);
			if (chan >= MAXMSDCHANS)
				break;
		
			// Next strip out the ions and dwell times
			p =	strtok(buffer, SEPCHARS );
			inc = 0;
			while ( p != NULL ) {

				if ( strstr(strlwr(p), "null") != NULL ) {
					MStable[chan][inc].ion = 0;
					MStable[chan][inc].dwell = 0;
					inc++;
				} else {
					ion = atof(p);
					if (ion >= 1) { 		// found ion
						p = strtok( NULL, SEPCHARS );
						dwell = atof(p);
						if (( dwell <= 1 ) && ( dwell > 0 )) {
							MStable[chan][inc].ion = ion;
							MStable[chan][inc].dwell = dwell;
							//printf ("%d,%d: %f %f\n", chan, inc, ion, dwell);
						} else {
							MStable[chan][inc].ion = 0;
							MStable[chan][inc].dwell = 0;
							fprintf(stderr, "Bad dwell time for channel %d, ion %f\n", chan, ion);
						}

						inc++;
					} else {
						MStable[chan][inc].ion = 0;
						MStable[chan][inc].dwell = 0;
						//printf("null ion: chan = %d, inc = %d\n", chan,inc);
					}

				}

				p = strtok( NULL, SEPCHARS );
			}
		}
	}

	fclose(fp);
	once = 1;

	return 0;

}

// Function takes a ion number and returns the MS channel number for
// a given time window.
int ion2chan( int win, float ion ) {

	int ch;
	float tol = 0.001;

	// Out of range variable
	if (win > MAXMSDIONS)
		return -1;

	// Scan MStable array for match
	for(ch=0; ch < MAXMSDCHANS; ch++) {
		if (((MStable[ch][win].ion - tol) < ion) && ((MStable[ch][win].ion + tol) > ion))
			return ch;
	}

	// No match in this time window
	return -1;

}

// Functions to pull data from MSD_Data and Time arrays.
long int MSD_Chan_Pull( int chan, int type ) {
	long msdDATA;
	static long msdTIMEold;

	if (currMSDPoint[chan] > MAXMSDPOINTS) 
		currMSDPoint[chan] = MAXMSDPOINTS;

	// type 0 is msd resp data, type 1 is msd time data.
	if ( type == 0 ) {
		msdDATA = MSD_Data_Array[chan][currMSDPoint[chan]];
		currMSDPoint[chan]++;
	} 
	else if ( type == 1 ) {		// real time displayed on text string.
		msdDATA = MSD_Time_Array[currMSDPoint[chan]-1];
		if ( msdDATA == MSDMISSING )
			msdDATA = msdTIMEold;
		else
			msdTIMEold = msdDATA;
	}
	else if ( type == 2 ) {		// this time needs to be monitonically increasing for rtg.
		msdDATA = MSD_Time_Array[currMSDPoint[chan]-1];
		if ( msdDATA == MSDMISSING )
			msdDATA = msdTIMEoldPlot++;
		else if ( msdDATA <= msdTIMEoldPlot ) {
			if ( msdDATA > msdTIMEoldPlot )
				msdDATA = msdDATA + 10;	
			else
				msdDATA = msdTIMEoldPlot + 10;
		}
		msdTIMEoldPlot = msdDATA;
	}

	return msdDATA;	
}




 typedef unsigned short WinNum;

 typedef long MSD_DataType;

MSD_DataType msdA_0, msdA_1, msdA_2, msdA_3, msdA_4, msdA_5, msdA_6, msdA_7, msdA_8;

int MSD_load( unsigned short IonWinNum ) {

	char *p;
	unsigned int chaninc[MAXMSDCHANS], inc, i, c;
	int chan = 0;
	float ion;

	// Initialize global currMSDPoint to 0
	for(c=0; c < MAXMSDCHANS; c++) {
		chaninc[c] = 0;
		currMSDPoint[c] = 0;
	}

	// Fills in MSD_Data_Array with "missing" data MSDMISSING
	for(i=0; i < MAXMSDPOINTS; i++) {
		for(c=0; c < MAXMSDCHANS; c++) {
			MSD_Data_Array[c][i] = MSDMISSING;
			if (c == 0)
				MSD_Time_Array[i] = MSDMISSING;
		}
	}

	// Parse data returned in string MSDresp
	p = strtok(MSDresp, ",");
	inc = 0;
	while( p != NULL ) {

		// Get ion number
		if ( (inc % 3) == 0 ) {
			ion = atof(p);
			chan = ion2chan(IonWinNum, ion);
			// printf("ion = %f, chan = %d\n", ion, chan);
		} 

		// response data
		else if ( (inc % 3) == 1 ) {
			// Set data array
			if ((chan >= 0) && (chan < MAXMSDCHANS)) {
				MSD_Data_Array[chan][chaninc[chan]] = atol(p);
				chaninc[chan]++;
				if (chaninc[chan] > MAXMSDPOINTS) {
					chaninc[chan] = MAXMSDPOINTS;
					break;
				}
			}
		} 

		// time data
		else if ( (inc % 3) == 2 ) {
			if (chan == 0)
				MSD_Time_Array[chaninc[chan] - 1] = atol(p);
		} 

		p = strtok(NULL, ",");
		inc++;
	}

	// Set MSDresp array to 0
	for (i=0; i<MAXSENDMSG; i++) 
		MSDresp[i] = '\0';
	
	return 1;

}		



	unsigned short InjectingInc_MSD = 0;


ULONG MSDchromtime;
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <sys/types.h>
#include "regnames.h"

#define MAXMON 	19		// should match number in msd driver

pid_t	MSDeng_proxy;
float 	MSDeng[MAXMON];

void InitializeMSDeng() {
	int param;
	static char once;

	if (once == 1) return;

	for (param=0; param<MAXMON; param++)
		MSDeng[param] = -99.0;

	once = 1;

}




 typedef double MSDdouble;
#include <sys/types.h>
#include "maycomm.h"
pid_t maycomm_proxy = 0;

TDLstruct tdl;

#define USELONGPATH  375	// use the long path TDL when less than 900 ppm
#define OffsetShortPath  150   // Offset to match long and short at switch
int P;



 typedef float tdlfloat;
 typedef float tdlfloas;
 typedef short tdlint6;
#include "integrate.h"
#include "tmctime.h"
#include "nl_dsp.h"

/* make sure the defined INTPEAKS in integrate.c
   equals the number of peaks integrated */

intStruct F11int;	
intStruct N2Oint;
intStruct SF6int;
intStruct CH4int;





int old_ssv1min;	
int old_ssvfold;
int firsthalf = -1;



 typedef float MixRatio;
MixRatio MR_F11;
MixRatio MR_N2O;
MixRatio MR_SF6;
MixRatio MR_CH4;
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include "nortlib.h"
#include "globmsg.h"
#include "ttdriver.h"
#include "dac.h"
#include "reveal.h"

#define PumpOFF 		600		// mbar (pump off at pressures greater than PumpOFF)
#define PumpON  		550		// mbar (pump on at pressures less than PumpON)
#define PANlampOFF 		100		// mbar (PAN lamp at press less than this)
#define PANlampON	    120 	// mbar (PAN lamp at press greather than this)
#define N2fail  -75				// psi (commented out below!!!!)

char revealMSG[REVEAL_MAXDATA];


#define		PressCH_1		12		// DAC channel number of press controller
#define		PressORG_1		20		// psi
#define		PressINC_1		0.3		// psi / sec
#define		PressMAX_1		45		// psi
#define 	Duration_1		45		// seconds 
float		PressSet_1;
int			SecCount_1;

#define		PressCH_2		13		// DAC channel number of press controller
#define		PressORG_2		20		// psi
#define		PressINC_2		0.3		// psi / sec
#define		PressMAX_2		45		// psi
#define 	Duration_2		45		// seconds 
float		PressSet_2;
int			SecCount_2;

int elecSF6_Fcnt = 0;
int elecF11_Fcnt = 0;
int elecCO_Fcnt = 0;
int elecPAN_Fcnt = 0;
int ELECMAXFAIL = 10;

  #include "nortlib.h"
  #include "tma.h"
  char ci_version[] = "$CGID: panthercmd.c: Sun Aug 21 20:21:02 2011 $";

  tma_state initialize_cmds_[] = {
       0, ">Telemetry Start\n",
       1, ">DAC Board Enable\n",
       2, "#5", /* PAN_Lamp_On */
       3, ">mode GC Safe\n",
       4, ">mode MSD Safe\n",
      19, ">Elec Bias SF6 200\n",
      20, ">Elec Bias F11 100\n",
      21, ">Elec Bias CO 250\n",
      22, ">Elec Bias PAN 254\n",
      22, "#16", /* REVEAL */
      -1, NULL
  };

  tma_state InletPumpOff_cmds_[] = {
       0, ">Pump Inlet Off\n",
       0, "#29", /* InletPumpOff_1_ */
       1, ">mode MSD safe\n",
       1, "#28", /* part_0_idle_ */
       6, "#30", /* InletPumpOff_end_ */
      -1, NULL
  };

  tma_state InletPumpON_cmds_[] = {
       0, ">Pump Inlet On\n",
       0, "#31", /* InletPumpON_1_ */
       1, ">mode MSD run\n",
       1, "#32", /* InletPumpON_end_ */
      -1, NULL
  };

  tma_state PANwait_cmds_[] = {
      -1, NULL
  };

  tma_state PAN_Lamp_On_cmds_[] = {
       0, ">PAN Lamp On\n",
       0, "#34", /* PAN_Lamp_On_1_ */
       5, "#35", /* PAN_Lamp_On_end_ */
      -1, NULL
  };

  tma_state PAN_Lamp_Off_cmds_[] = {
       0, ">PAN Lamp Off\n",
       0, "#36", /* PAN_Lamp_Off_1_ */
       5, "#37", /* PAN_Lamp_Off_end_ */
      -1, NULL
  };

  tma_state PressSweepIdle1_cmds_[] = {
      -1, NULL
  };

  tma_state MS1PressSweep_cmds_[] = {
      -1, NULL
  };

  tma_state PressSweepSet1_cmds_[] = {
      20, "#10", /* DoPressSweep1 */
      -1, NULL
  };

  tma_state DoPressSweep1_cmds_[] = {
      -1, NULL
  };

  tma_state PressSweepIdle2_cmds_[] = {
      -1, NULL
  };

  tma_state MS2PressSweep_cmds_[] = {
      -1, NULL
  };

  tma_state PressSweepSet2_cmds_[] = {
      20, "#14", /* DoPressSweep2 */
      -1, NULL
  };

  tma_state DoPressSweep2_cmds_[] = {
      -1, NULL
  };

  tma_state REVEAL_Idle_cmds_[] = {
      -1, NULL
  };

  tma_state REVEAL_cmds_[] = {
      -1, NULL
  };

  tma_state REVEAL_int_cmds_[] = {
      -1, NULL
  };

  tma_state CheckPilotOff_cmds_[] = {
      -1, NULL
  };

  tma_state CheckN2_cmds_[] = {
      -1, NULL
  };

  tma_state StartCheck_cmds_[] = {
      -1, NULL
  };

  tma_state CheckElectrometers_cmds_[] = {
      -1, NULL
  };

  tma_state resetBiases_cmds_[] = {
       1, ">Elec Bias SF6 200\n",
       2, ">Elec Bias F11 100\n",
       3, ">Elec Bias CO 250\n",
       4, ">Elec Bias PAN 254\n",
       4, "#21", /* CheckElectrometers */
      -1, NULL
  };

  tma_state sendSF6reset_cmds_[] = {
       0, ">Elec Reset SF6\n",
       4, "#22", /* resetBiases */
      -1, NULL
  };

  tma_state sendF11reset_cmds_[] = {
       0, ">Elec Reset F11\n",
       4, "#22", /* resetBiases */
      -1, NULL
  };

  tma_state sendCOreset_cmds_[] = {
       0, ">Elec Reset CO\n",
       4, "#22", /* resetBiases */
      -1, NULL
  };

  tma_state sendPANreset_cmds_[] = {
       0, ">Elec Reset PAN\n",
       4, "#22", /* resetBiases */
      -1, NULL
  };

  tma_state Shutdown_cmds_[] = {
       1, ">Shutdown\n",
      -1, NULL
  };

  const int tma_n_partitions = 9;

#ifdef CONSOLE_INIT
  #error CONSOLE_INIT is obsolete
#endif
#ifdef MSG_LABEL
  #error MSG_LABEL is obsolete
#endif

#ifdef N_CONSOLES
  #include "nl_cons.h"
  #ifndef DATA_ATTR
	#define DATA_ATTR 7
  #endif

  #define cdisplay(d,r,c,s) nlcon_display(d,r,c,s,DATA_ATTR)
  #define display_(d,r,c,t,v,s) {\
	static t sv_;\
	if (v != sv_) { cdisplay(d,r,c,s); sv_ = v; }\
  }
#endif


unsigned char V0 = 0x1;
unsigned char V1 = 0x1;
unsigned char V2 = 0x1;
unsigned char V3 = 0x1;
unsigned char V4 = 0x1;
unsigned char V5 = 0x1;
unsigned char V6 = 0x1;
unsigned char V7 = 0x1;
unsigned char V8 = 0x1;
unsigned char V9 = 0x1;
unsigned char V10 = 0x3;
unsigned char V11 = 0x1;
unsigned char V12 = 0x7;
unsigned char V13 = 0x1;
unsigned char V14 = 0x1;
unsigned char V15 = 0x1;
unsigned char V16 = 0x1;
unsigned char V17 = 0x1;
unsigned char V18 = 0x1;
unsigned char V19 = 0x1;
unsigned char V20 = 0x1;
unsigned char V21 = 0x3;
unsigned char V22 = 0x1;
unsigned char V23 = 0x3;
unsigned char V24 = 0x1;
unsigned char V25 = 0x3;
unsigned char V26 = 0x3F;
unsigned char V27 = 0x1;
unsigned char V28 = 0x3;
unsigned char V29 = 0x3;
unsigned char V30 = 0x3;
unsigned char V31 = 0x3;
adT PresE_SF6;
adT PresL_He;
GC_Ctr GC_Ctr_F11;
GC_Ctr GC_Ctr_CO;
GC_Ctr GC_Ctr_PAN;
tdlfloas tdlP;
tdlfloat tdlsH2O;
tdlfloat tdllH2O;
union {
  struct {
    UINT MFCtr;
    GC_Ctr GC_Ctr_SF6;
    vdc_chan VoltE_CO;
    InjStateT InjState;
    Bit_Op_Cl SLoopMSout;
    vdc_chan VoltB_CO;
    vdc_chan VoltM_CO;
    adT PresE_CO;
    adT PresHead_P;
    UINT CurrFile;
    Bit_Off_On pelt1State;
    UINT CurrInj;
    Bit_HI_LO pilotTrip;
    adT_flow FlowM_SF6;
    adT PresMS1;
    UINT Synch;
  } U0;
  struct {
    char U2[2];
    MSD_DataType MSD_TimePlot;
    vdc_chan VoltE_F11;
    vdc_chan VoltBP_CO;
    vdc_chan VoltBP_SF6;
    vdc_chan VoltB_SF6;
    vdc_chan VoltM_SF6;
    adT PresBP_CO;
    adT_pump rpm_Ipump;
    adT_flow FlowM_CO;
    adT PresMS2;
    adT Trap1_re;
  } U1;
  struct {
    char U4[6];
    vdc_chan VoltE_PAN;
    vdc_chan VoltE_SF6;
    vdc_chan VoltB_F11;
    vdc_chan VoltM_F11;
    adT PresE_F11;
    adT PresE_SF6;
    adT_flow FlowB_CO;
    adT_flow FlowB_SF6;
    adT ColT_MS1;
    adT ColT_MS2;
  } U3;
  struct {
    char U6[6];
    adT Trap1_set;
    vdc_chan VoltBP_F11;
    vdc_chan VoltM_PAN;
    adT_flow FlowSrc_PAN;
    adT PresBP_PAN;
    adT PresBP_F11;
    adT PresBP_SF6;
    adT_flow FlowM_F11;
    adT ColT_PAN;
    adT PresH_N2;
  } U5;
  struct {
    char U8[6];
    adT PresL_N2;
    vdc_chan VoltB_PAN;
    vdc_chan VoltE_5;
    vdc_chan VoltBP_PAN;
    adT PresE_PAN;
    adT PresSrc_PAN;
    adT_flow FlowB_F11;
    adT Pres1_PAN;
    adT PresH_He;
    adT PresL_He;
  } U7;
  struct {
    char U10[6];
    adT Temp_F11sl;
    adT Trap2_re;
    adT Trap2_set;
    vdc_chan VoltBP_5;
    vdc_chan VoltMS2;
    vdc_chan VoltMS1;
    adT Pres2_PAN;
    adT PresBP_5;
    adT PresL_CO2;
    adT Temp_elect;
  } U9;
  struct {
    char U12[6];
    vdc_pow Pow_p28sec;
    adT PresL_N2O;
    adT Pres_Inlet;
    adT Pres_SL;
    dacMSpr PresMS1sp;
    dacMSpr PresMS2sp;
    adT PresE_5;
    adT PresH_CO2;
    adT Temp_COsl;
    vdc_pow Pow_p28pri;
  } U11;
  struct {
    char U14[6];
    Bit_Off_On trap1heat;
    Bit_Off_On trap2heat;
    adT Temp_GasBot;
    adT PresH_N2O;
    adT PresH_PAN;
    adT Flow_PANsl;
    adT Flow_Packsl;
    adT Flow_MSsl;
    adT PresL_Cal2;
    adT Temp_stack;
    vdc_pow Pow_p15pel2;
  } U13;
  struct {
    char U16[6];
    OmegaT SF6_Post;
    OmegaTsp SF6_Post_Sp;
    vdc_pow Pow_p5;
    adT PresL_PAN;
    adT PresL_ZA;
    adT PresH_ZA;
    adT PresH_Cal1;
    adT PresH_Cal2;
    adT Temp_SF6sl;
    vdc_pow Pow_p15pel1;
    vdc_pow Pow_p12;
  } U15;
  struct {
    char U18[6];
    valveMS2text valv_MS2;
    valveMS1text valv_MS1;
    Bit_HI_LO faildummy;
    valvetext valv_CO;
    adT Temp_GSVbo;
    adT Temp_Ipump;
    adT Temp_PANlmp;
    adT Temp_PANsl;
    adT PresL_Cal1;
    vdc_pow Pow_p24gsv;
    vdc_pow Pow_m15;
    vdc_pow Pow_p15;
  } U17;
  struct {
    char U20[6];
    MSD_DataType MSD_Time;
    Bit_Cl_Op SLoopIN;
    WinNum IonWinNum;
    Bit_Cl_Op SLoopOUT;
    OmegaT Trap1_CB;
    Bit_Off_On PANflowCont;
    Bit_Cl_Op PANflsh;
    Bit_Off_On PANlamp;
    Bit_Air_Cal PANsol1;
    Bit_Off_On trap2relay;
    UCHAR GCstate;
    UCHAR MSDstate;
    adT Temp_PANsrc;
    Bit_Off_On pelt2State;
    UINT CurrInj_MSD;
    vdc_pow Pow_p24ms;
    OmegaT F11_ECD;
    OmegaTsp F11_ECD_Sp;
  } U19;
  struct {
    char U22[6];
    MSDdouble msdEEGY;
    OmegaT PAN_ECD;
    OmegaTsp PAN_ECD_Sp;
    OmegaTsp Trap1_CB_Sp;
    Bit_Off_On trap1relay;
    OmegaT CO_Col;
    OmegaTsp CO_Col_Sp;
    Bit_Cl_Op PANsol2;
    Bit_Off_On PANsol3;
    Bit_Op_Cl PANsol4;
    UINT CurrFile_MSD;
    GC_Ctr GC_Ctr_CO;
    OmegaT F11_Col;
    OmegaTsp F11_Col_Sp;
    OmegaT SF6_ECD;
    OmegaTsp SF6_ECD_Sp;
  } U21;
  struct {
    char U24[6];
    MSDdouble msdFSEL;
    valvetext valv_F11;
    valvetext valv_SF6;
    valvT ssv2;
    valvT ssv1;
    OmegaT Trap2_CB;
    OmegaTsp Trap2_CB_Sp;
    OmegaT CO_ECD;
    OmegaTsp CO_ECD_Sp;
    MSD_DataType MSD_Chan0;
    tdlfloas tdlP;
    OmegaT SF6_Col;
    OmegaTsp SF6_Col_Sp;
    GC_Ctr GC_Ctr_PAN;
  } U23;
  struct {
    char U26[6];
    MSDdouble msdEMUL;
    MSD_DataType MSD_Chan4;
    MSD_DataType MSD_Chan3;
    MSD_DataType MSD_Chan2;
    MSD_DataType MSD_Chan1;
    MSDdouble msdECUR;
    GC_Ctr GC_Ctr_F11;
    ULONG maycX;
  } U25;
  struct {
    char U28[6];
    MSDdouble msdMASO;
    MSDdouble msdREP;
    MSDdouble msdIPOL;
    MSDdouble msdAMUO;
    MSDdouble msdAMUG;
  } U27;
  struct {
    char U30[6];
    tdlint6  tdllZer;
    tdlint6  tdllPos;
    valvetext valv_PAN;
    UINT loadMSDarray;
    MSDdouble msdENT;
    MSDdouble msdIFOC;
    MSDdouble msdENTO;
    MSDdouble msdMMW;
  } U29;
  struct {
    char U32[10];
    MSD_DataType MSD_Chan5;
    MSDdouble msdCAL;
    MSDdouble msdHEDEN;
    MSDdouble msdQUAD;
    MSDdouble msdSRCTEMP;
  } U31;
  struct {
    char U34[10];
    tdlint6  tdllPow;
    tdlint6  tdllAmp;
    MSDdouble msdMASG;
    MSDdouble msdTURBOPCT;
    tdlfloas tdlT;
    tdlfloat tdlbH2O;
  } U33;
  struct {
    char U36[14];
    tdlint6  tdlsZer;
    tdlint6  tdlsPos;
    tdlint6  tdlsPow;
    tdlint6  tdlsAmp;
    tdlfloat tdllH2O;
    tdlfloat tdlsH2O;
  } U35;
} *home;

static void VSET_21_(unsigned short newstate) {
  static unsigned short oldstate;
  
  switch (oldstate) {
  }
  oldstate = newstate;
  switch (newstate) {
  }
}
static void VSET_20_(unsigned short newstate) {
  static unsigned short oldstate;
  
  switch (oldstate) {
  }
  oldstate = newstate;
  switch (newstate) {
  }
}
static void VSET_19_(unsigned short newstate) {
  static unsigned short oldstate;
  
  switch (oldstate) {
  }
  oldstate = newstate;
  switch (newstate) {
  }
}
static void VSET_18_(unsigned short newstate) {
  static unsigned short oldstate;
  
  switch (oldstate) {
  }
  oldstate = newstate;
  switch (newstate) {
  }
}
static void VSET_17_(unsigned short newstate) {
  static unsigned short oldstate;
  
  switch (oldstate) {
  }
  oldstate = newstate;
  switch (newstate) {
  }
}
static void VSET_16_(unsigned short newstate) {
  static unsigned short oldstate;
  
  switch (oldstate) {
  }
  oldstate = newstate;
  switch (newstate) {
  }
}
static void VSET_15_(unsigned short newstate) {
  static unsigned short oldstate;
  
  switch (oldstate) {
  }
  oldstate = newstate;
  switch (newstate) {
  }
}
static void VSET_14_(unsigned short newstate) {
  static unsigned short oldstate;
  
  switch (oldstate) {
    case 5: /* PAN_Lamp_Off_end_ */
      V20 |= 0x1;
      break;
    case 4: /* PAN_Lamp_Off_1_ */
      V19 |= 0x1;
      break;
    case 3: /* PAN_Lamp_On_end_ */
      V18 |= 0x1;
      break;
    case 2: /* PAN_Lamp_On_1_ */
      V17 |= 0x1;
      break;
  }
  oldstate = newstate;
  switch (newstate) {
    case 5: /* PAN_Lamp_Off_end_ */
      V20 &= ~0x1;
      break;
    case 4: /* PAN_Lamp_Off_1_ */
      V19 &= ~0x1;
      break;
    case 3: /* PAN_Lamp_On_end_ */
      V18 &= ~0x1;
      break;
    case 2: /* PAN_Lamp_On_1_ */
      V17 &= ~0x1;
      break;
  }
}
static void VSET_13_(unsigned short newstate) {
  static unsigned short oldstate;
  
  switch (oldstate) {
    case 5: /* InletPumpON_end_ */
      V16 |= 0x1;
      break;
    case 4: /* InletPumpON_1_ */
      V15 |= 0x1;
      break;
    case 3: /* InletPumpOff_end_ */
      V14 |= 0x1;
      break;
    case 2: /* InletPumpOff_1_ */
      V13 |= 0x1;
      break;
  }
  oldstate = newstate;
  switch (newstate) {
    case 5: /* InletPumpON_end_ */
      V16 &= ~0x1;
      break;
    case 4: /* InletPumpON_1_ */
      V15 &= ~0x1;
      break;
    case 3: /* InletPumpOff_end_ */
      V14 &= ~0x1;
      break;
    case 2: /* InletPumpOff_1_ */
      V13 &= ~0x1;
      break;
  }
}
static void VSET_12_(unsigned short newstate) {
  static unsigned short oldstate;
  
  switch (oldstate) {
    case 2: /* CheckElectrometers */ {
        V31 |= 0x1;
        V30 |= 0x1;
        V29 |= 0x1;
        V28 |= 0x1;
      }
      break;
  }
  oldstate = newstate;
  switch (newstate) {
    case 8: /* Shutdown */ {
        {
          tma_init_state( 8, Shutdown_cmds_, "Shutdown" ); VSET_21_(1);
        }
      }
      break;
    case 7: /* sendPANreset */ {
        {
          tma_init_state( 8, sendPANreset_cmds_, "sendPANreset" ); VSET_21_(1);
        } { elecPAN_Fcnt++; }
      }
      break;
    case 6: /* sendCOreset */ {
        {
          tma_init_state( 8, sendCOreset_cmds_, "sendCOreset" ); VSET_21_(1);
        } { elecCO_Fcnt++; }
      }
      break;
    case 5: /* sendF11reset */ {
        {
          tma_init_state( 8, sendF11reset_cmds_, "sendF11reset" ); VSET_21_(1);
        } { elecF11_Fcnt++; }
      }
      break;
    case 4: /* sendSF6reset */ {
        {
          tma_init_state( 8, sendSF6reset_cmds_, "sendSF6reset" ); VSET_21_(1);
        } { elecSF6_Fcnt++; }
      }
      break;
    case 3: /* resetBiases */ {
        {
          tma_init_state( 8, resetBiases_cmds_, "resetBiases" ); VSET_21_(1);
        }
      }
      break;
    case 2: /* CheckElectrometers */ {
        V31 &= ~0x1;
        V30 &= ~0x1;
        V29 &= ~0x1;
        V28 &= ~0x1;
        {
          tma_init_state( 8, CheckElectrometers_cmds_, "CheckElectrometers" ); VSET_21_(1);
        }if (!(V28)) {
          { if ( (elecSF6_Fcnt < ELECMAXFAIL ) && (ecdA_SF6 == -9999)) VSET_12_(4); }
        }if (!(V29)) {
          { if ( (elecF11_Fcnt < ELECMAXFAIL ) && (ecdA_F11 == -9999)) VSET_12_(5); }
        }if (!(V30)) {
          { if ( (elecCO_Fcnt < ELECMAXFAIL ) && (ecdA_CO == -9999)) VSET_12_(6); }
        }if (!(V31)) {
          { if ( (elecPAN_Fcnt < ELECMAXFAIL ) && (ecdA_PAN == -9999)) VSET_12_(7); }
        }
      }
      break;
    case 1: /* StartCheck */ {
        {
          tma_init_state( 8, StartCheck_cmds_, "StartCheck" ); VSET_21_(1);
        }
      }
      break;
  }
}
static void VSET_11_(unsigned short newstate) {
  static unsigned short oldstate;
  
  switch (oldstate) {
  }
  oldstate = newstate;
  switch (newstate) {
    case 1: /* CheckN2 */ {
        {
          tma_init_state( 7, CheckN2_cmds_, "CheckN2" ); VSET_20_(1);
        }
      }
      break;
  }
}
static void VSET_10_(unsigned short newstate) {
  static unsigned short oldstate;
  
  switch (oldstate) {
    case 1: /* CheckPilotOff */
      V27 |= 0x1;
      break;
  }
  oldstate = newstate;
  switch (newstate) {
    case 1: /* CheckPilotOff */ {
        V27 &= ~0x1;
        {
          tma_init_state( 6, CheckPilotOff_cmds_, "CheckPilotOff" ); VSET_19_(1);
        }
      }
      break;
  }
}
static void VSET_9_(unsigned short newstate) {
  static unsigned short oldstate;
  
  switch (oldstate) {
    case 1: /* REVEAL_int */
      V26 |= 0x2;
      break;
  }
  oldstate = newstate;
  switch (newstate) {
    case 1: /* REVEAL_int */ {
        V26 &= ~0x2;
        {
          tma_init_state( 5, REVEAL_int_cmds_, "REVEAL_int" ); VSET_18_(1);
        }if (!(V26)) {
          {
          		sprintf( revealMSG, "xPMR:%06.1f,%06.1f,%06.1f,%06.1f", 
          			MR_F11, MR_N2O, MR_SF6, MR_CH4 );
          		if ( strlen(revealMSG) <= REVEAL_MAXDATA ) 
          			send2reveal( &revealMSG );
          		msg( 0, "** REVEAL:%s", revealMSG );
          	}
        }
      }
      break;
  }
}
static void VSET_8_(unsigned short newstate) {
  static unsigned short oldstate;
  
  switch (oldstate) {
    case 2: /* REVEAL */
      V25 |= 0x1;
      break;
  }
  oldstate = newstate;
  switch (newstate) {
    case 2: /* REVEAL */ {
        V25 &= ~0x1;
        {
          tma_init_state( 4, REVEAL_cmds_, "REVEAL" ); VSET_17_(1);
        }
      }
      break;
    case 1: /* REVEAL_Idle */ {
        {
          tma_init_state( 4, REVEAL_Idle_cmds_, "REVEAL_Idle" ); VSET_17_(1);
        }
      }
      break;
  }
}
static void VSET_7_(unsigned short newstate) {
  static unsigned short oldstate;
  
  switch (oldstate) {
    case 4: /* DoPressSweep2 */
      V24 |= 0x1;
      break;
    case 2: /* MS2PressSweep */
      V23 |= 0x2;
      break;
  }
  oldstate = newstate;
  switch (newstate) {
    case 4: /* DoPressSweep2 */ {
        V24 &= ~0x1;
        {
          tma_init_state( 3, DoPressSweep2_cmds_, "DoPressSweep2" ); VSET_16_(1);
        }
      }
      break;
    case 3: /* PressSweepSet2 */ {
        {
          tma_init_state( 3, PressSweepSet2_cmds_, "PressSweepSet2" ); VSET_16_(1);
        } { SecCount_2 = 0;
        		PressSet_2 = PressORG_2;
        	    SetPress( PressCH_2, PressORG_2, 1 ); 
        	  }
      }
      break;
    case 2: /* MS2PressSweep */ {
        V23 &= ~0x2;
        {
          tma_init_state( 3, MS2PressSweep_cmds_, "MS2PressSweep" ); VSET_16_(1);
        }if (!(V23)) {
          { VSET_7_(3); }
        }
      }
      break;
    case 1: /* PressSweepIdle2 */ {
        {
          tma_init_state( 3, PressSweepIdle2_cmds_, "PressSweepIdle2" ); VSET_16_(1);
        }
      }
      break;
  }
}
static void VSET_6_(unsigned short newstate) {
  static unsigned short oldstate;
  
  switch (oldstate) {
    case 4: /* DoPressSweep1 */
      V22 |= 0x1;
      break;
    case 2: /* MS1PressSweep */
      V21 |= 0x2;
      break;
  }
  oldstate = newstate;
  switch (newstate) {
    case 4: /* DoPressSweep1 */ {
        V22 &= ~0x1;
        {
          tma_init_state( 2, DoPressSweep1_cmds_, "DoPressSweep1" ); VSET_15_(1);
        }
      }
      break;
    case 3: /* PressSweepSet1 */ {
        {
          tma_init_state( 2, PressSweepSet1_cmds_, "PressSweepSet1" ); VSET_15_(1);
        } { SecCount_1 = 0;
        		PressSet_1 = PressORG_1;
        	    SetPress( PressCH_1, PressORG_1, 1 ); 
        	  }
      }
      break;
    case 2: /* MS1PressSweep */ {
        V21 &= ~0x2;
        {
          tma_init_state( 2, MS1PressSweep_cmds_, "MS1PressSweep" ); VSET_15_(1);
        }if (!(V21)) {
          { VSET_6_(3); }
        }
      }
      break;
    case 1: /* PressSweepIdle1 */ {
        {
          tma_init_state( 2, PressSweepIdle1_cmds_, "PressSweepIdle1" ); VSET_15_(1);
        }
      }
      break;
  }
}
static void VSET_5_(unsigned short newstate) {
  static unsigned short oldstate;
  
  switch (oldstate) {
  }
  oldstate = newstate;
  switch (newstate) {
    case 3: /* PAN_Lamp_Off */ {
        {
          tma_init_state( 1, PAN_Lamp_Off_cmds_, "PAN_Lamp_Off" ); VSET_14_(1);
        }
      }
      break;
    case 2: /* PAN_Lamp_On */ {
        {
          tma_init_state( 1, PAN_Lamp_On_cmds_, "PAN_Lamp_On" ); VSET_14_(1);
        }
      }
      break;
    case 1: /* PANwait */ {
        {
          tma_init_state( 1, PANwait_cmds_, "PANwait" ); VSET_14_(1);
        }
      }
      break;
  }
}
static void VSET_4_(unsigned short newstate) {
  static unsigned short oldstate;
  
  switch (oldstate) {
  }
  oldstate = newstate;
  switch (newstate) {
    case 3: /* InletPumpON */ {
        {
          tma_init_state( 0, InletPumpON_cmds_, "InletPumpON" ); VSET_13_(1);
        }
      }
      break;
    case 2: /* InletPumpOff */ {
        {
          tma_init_state( 0, InletPumpOff_cmds_, "InletPumpOff" ); VSET_13_(1);
        }
      }
      break;
    case 1: /* initialize */ {
        {
          tma_init_state( 0, initialize_cmds_, "initialize" ); VSET_13_(1);
        }
      }
      break;
  }
}
static void VSET_3_(unsigned short newstate) {
  static unsigned short oldstate;
  
  switch (oldstate) {
    case 2: /* MaycommTog */
      V9 |= 0x1;
      break;
  }
  oldstate = newstate;
  switch (newstate) {
    case 2: /* MaycommTog */
      V9 &= ~0x1;
      break;
  }
}
static void VSET_2_(unsigned short newstate) {
  static unsigned short oldstate;
  
  switch (oldstate) {
    case 3: /* Injection_MSD */
      V7 |= 0x1;
      break;
    case 2: /* Injecting_MSD */ {
        V23 |= 0x1;
        V21 |= 0x1;
        V8 |= 0x1;
        V6 |= 0x1;
      }
      break;
  }
  oldstate = newstate;
  switch (newstate) {
    case 3: /* Injection_MSD */
      V7 &= ~0x1;
      break;
    case 2: /* Injecting_MSD */ {
        V23 &= ~0x1;
        V21 &= ~0x1;
        V8 &= ~0x1;
        V6 &= ~0x1;
        {
        	msdTIMEoldPlot = 0;
        }if (!(V21)) {
          { VSET_6_(3); }
        }if (!(V23)) {
          { VSET_7_(3); }
        }
      }
      break;
    case 1: /* NotInjecting_MSD */ {
        {
        	ReadMSDionFile( MSDIONFILE );
        } {
        	InitializeMSDeng();
        }
      }
      break;
  }
}
static void VSET_1_(unsigned short newstate) {
  static unsigned short oldstate;
  
  switch (oldstate) {
    case 2: /* GCTog */
      V4 |= 0x1;
      break;
  }
  oldstate = newstate;
  switch (newstate) {
    case 2: /* GCTog */
      V4 &= ~0x1;
      break;
  }
}
static void VSET_0_(unsigned short newstate) {
  static unsigned short oldstate;
  
  switch (oldstate) {
    case 3: /* Injection */ {
        V12 |= 0x1;
        V1 |= 0x1;
      }
      break;
    case 2: /* Injecting */ {
        V26 |= 0x1;
        V11 |= 0x1;
        V5 |= 0x1;
        V2 |= 0x1;
        V0 |= 0x1;
      }
      break;
  }
  oldstate = newstate;
  switch (newstate) {
    case 3: /* Injection */ {
        V12 &= ~0x1;
        V1 &= ~0x1;
        { 
        	MR_F11 = MRres( 0 ); {
          V26 &= ~0x4;
          if (!(V26)) {
            {
            		sprintf( revealMSG, "xPMR:%06.1f,%06.1f,%06.1f,%06.1f", 
            			MR_F11, MR_N2O, MR_SF6, MR_CH4 );
            		if ( strlen(revealMSG) <= REVEAL_MAXDATA ) 
            			send2reveal( &revealMSG );
            		msg( 0, "** REVEAL:%s", revealMSG );
            	}
          }
        }
        } { 
        	MR_N2O = MRres( 1 ); {
          V26 &= ~0x8;
          if (!(V26)) {
            {
            		sprintf( revealMSG, "xPMR:%06.1f,%06.1f,%06.1f,%06.1f", 
            			MR_F11, MR_N2O, MR_SF6, MR_CH4 );
            		if ( strlen(revealMSG) <= REVEAL_MAXDATA ) 
            			send2reveal( &revealMSG );
            		msg( 0, "** REVEAL:%s", revealMSG );
            	}
          }
        }
        } { 
        	MR_SF6 = MRres( 2 ); {
          V26 &= ~0x10;
          if (!(V26)) {
            {
            		sprintf( revealMSG, "xPMR:%06.1f,%06.1f,%06.1f,%06.1f", 
            			MR_F11, MR_N2O, MR_SF6, MR_CH4 );
            		if ( strlen(revealMSG) <= REVEAL_MAXDATA ) 
            			send2reveal( &revealMSG );
            		msg( 0, "** REVEAL:%s", revealMSG );
            	}
          }
        }
        } { 
        	MR_CH4 = MRres( 3 ); {
          V26 &= ~0x20;
          if (!(V26)) {
            {
            		sprintf( revealMSG, "xPMR:%06.1f,%06.1f,%06.1f,%06.1f", 
            			MR_F11, MR_N2O, MR_SF6, MR_CH4 );
            		if ( strlen(revealMSG) <= REVEAL_MAXDATA ) 
            			send2reveal( &revealMSG );
            		msg( 0, "** REVEAL:%s", revealMSG );
            	}
          }
        }
        }
      }
      break;
    case 2: /* Injecting */ {
        V26 &= ~0x1;
        V11 &= ~0x1;
        V5 &= ~0x1;
        V2 &= ~0x1;
        V0 &= ~0x1;
        {
            firsthalf = (++firsthalf == 2) ? 0 : 1;
        }if (!(V26)) {
          {
          		sprintf( revealMSG, "xPMR:%06.1f,%06.1f,%06.1f,%06.1f", 
          			MR_F11, MR_N2O, MR_SF6, MR_CH4 );
          		if ( strlen(revealMSG) <= REVEAL_MAXDATA ) 
          			send2reveal( &revealMSG );
          		msg( 0, "** REVEAL:%s", revealMSG );
          	}
        }
      }
      break;
    case 1: /* NotInjecting */ {
        {
        	F11int.mol = "f11";		
        	F11int.pnum = 0;		
        	F11int.strt = 4;		
        	F11int.stop = 22;		
        	F11int.calval = 248.02;	
        	F11int.calssv = 2;		
        	F11int.delay = 70;		
        
        	N2Oint.mol = "n2o";		
        	N2Oint.pnum = 1;		
        	N2Oint.strt = 48;		
        	N2Oint.stop = 68;		
        	N2Oint.calval = 322.55;	
        	N2Oint.calssv = 2;		
        	N2Oint.delay = 0;
        
        	SF6int.mol = "sf6";		
        	SF6int.pnum = 2;		
        	SF6int.strt = 36;		
        	SF6int.stop = 44;		
        	SF6int.calval = 6.91;	
        	SF6int.calssv = 2;		
        	SF6int.delay = 0;
        
        	CH4int.mol = "ch4";		
        	CH4int.pnum = 3;		
        	CH4int.strt = 17;		
        	CH4int.stop = 36;		
        	CH4int.calval = 1828.7;	
        	CH4int.calssv = 2;		
        	CH4int.delay = 70;		
        
        } {
            firsthalf = -1;
        }
      }
      break;
  }
}
static void tminitfunc(void) {VSET_0_(1);VSET_1_(1);VSET_2_(1);VSET_3_(1);VSET_4_(1);VSET_5_(1);VSET_6_(1);VSET_7_(1);VSET_8_(1);VSET_9_(1);VSET_10_(1);VSET_11_(1);VSET_12_(1);VSET_13_(1);VSET_14_(1);VSET_15_(1);VSET_16_(1);VSET_17_(1);VSET_18_(1);VSET_19_(1);VSET_20_(1);VSET_21_(1);
}
#define TMINITFUNC tminitfunc()

static void nullfunc(void);
static void BF2_0(void) {
  GC_Ctr_PAN = home->U23.GC_Ctr_PAN;
  GC_Ctr_F11 = home->U25.GC_Ctr_F11;
  GC_Ctr_CO = home->U21.GC_Ctr_CO; {
    V12 &= ~0x4;
    V3 &= ~0x1;
  }
  {
  
  	for(chanInc=0; chanInc<MAXMSDCHANS; chanInc++) {
  		MSD_ChanX = MSDMISSING;
  		switch( chanInc ) {
  			case 0:
  				MSD_ChanX = home->U23.MSD_Chan0; break;
  			case 1:
  				MSD_ChanX = home->U25.MSD_Chan1; break;
  			case 2:
  				MSD_ChanX = home->U25.MSD_Chan2; break;
  			case 3:
  				MSD_ChanX = home->U25.MSD_Chan3; break;
  			case 4:
  				MSD_ChanX = home->U25.MSD_Chan4; break;
  			case 5:
  				MSD_ChanX = home->U31.MSD_Chan5; break;
  			case 6:
  				MSD_ChanX = home->U31.MSD_Chan5; break;
  			case 7:
  				MSD_ChanX = home->U31.MSD_Chan5; break;
  			default:
  				chanInc = MAXMSDCHANS-1; MSD_ChanX = MSDMISSING; break;
  		}
  
  		if ( MSD_ChanX > 0 ) {
  			msd_sum[chanInc] += MSD_ChanX;
  			MSchanAvg[chanInc]++;
  		}
  	}
  }
}

static void BF32_0(void) {
  BF2_0();
  {if (!(V1)) {
    { CHROMtime += 1; InjectingInc = 0;V12 &= ~0x2;
    }
  }if (!(V2)) {
    { 
    	if (InjectingInc == 0 ) {
    		CHROMtime = 1; 
    		InjectingInc = 1;
    	}
    	else CHROMtime += 1;V12 &= ~0x2;
    }
  }
  }
  {	
  	if (rs485_proxy != 0)  Trigger ( rs485_proxy );
  }
  {
  	if (ECDresp_proxy != 0) Trigger ( ECDresp_proxy );
  }
  {if (!(V4)) {
    { VSET_1_(1);
    	}
  }if (!(V5)) {
    V5 |= 0x1;
    { VSET_1_(2);
    		ecdSF6x = 0.0;
    		ecdF11x = 0.0;
    		ecdCOx  = 0.0;
    		ecdPANx = 0.0;
    	}
  }
  
  	if ( ecdSF6x > NUMSECSXAXIS ) { VSET_1_(2);
  		ecdSF6x = 0.0;
  		ecdF11x = 0.0;
  		ecdCOx  = 0.0;
  		ecdPANx = 0.0;
  	}
  }
  {
  	if ( DetAvgCt1 > 0 ) {
  		ecdA_SF6 = ecd_sum1/DetAvgCt1;
  		ecdA_SF6save = ecdA_SF6;
  		DetAvgCt1 = 0;
  		ecd_sum1 = 0;
  		DetAvgOffline1 = 0;
  	} 
  	else if (( ecdA_SF6save > 0 ) && ( DetAvgOffline1 < 1 )) {
  		DetAvgOffline1++;
  		ecdA_SF6 = ecdA_SF6save;
  	}
  	else {
  		ecdA_SF6 = ECDOFFLINE;
  		ecdA_SF6save = 0;
  	} {
    V28 &= ~0x2;
    if (!(V28)) {
      { if ( (elecSF6_Fcnt < ELECMAXFAIL ) && (ecdA_SF6 == -9999)) VSET_12_(4); }
    }
  }
  if ( DetAvgCt2 > 0 ) {
  		ecdA_F11 = ecd_sum2/DetAvgCt2;
  		ecdA_F11save = ecdA_F11;
  		DetAvgCt2 = 0;
  		ecd_sum2 = 0;
  		DetAvgOffline2 = 0;
  	} 
  	else if (( ecdA_F11save > 0 ) && ( DetAvgOffline2 < 1 )) {
  		DetAvgOffline2++;
  		ecdA_F11 = ecdA_F11save;
  	}
  	else {
  		ecdA_F11 = ECDOFFLINE;
  		ecdA_F11save = 0;
  	} {
    V29 &= ~0x2;
    if (!(V29)) {
      { if ( (elecF11_Fcnt < ELECMAXFAIL ) && (ecdA_F11 == -9999)) VSET_12_(5); }
    }
  }
  if ( DetAvgCt3 > 0 ) {
  		ecdA_CO = ecd_sum3/DetAvgCt3;
  		ecdA_COsave = ecdA_CO;
  		DetAvgCt3 = 0;
  		ecd_sum3 = 0;
  		DetAvgOffline3 = 0;
  	} 
  	else if (( ecdA_COsave > 0 ) && ( DetAvgOffline3 < 1 )) {
  		DetAvgOffline3++;
  		ecdA_CO = ecdA_COsave;
  	}
  	else {
  		ecdA_CO = ECDOFFLINE;
  		ecdA_COsave = 0;
  	} {
    V30 &= ~0x2;
    if (!(V30)) {
      { if ( (elecCO_Fcnt < ELECMAXFAIL ) && (ecdA_CO == -9999)) VSET_12_(6); }
    }
  }
  if ( DetAvgCt4 > 0 ) {
  		ecdA_PAN = ecd_sum4/DetAvgCt4;
  		ecdA_PANsave = ecdA_PAN;
  		DetAvgCt4 = 0;
  		ecd_sum4 = 0;
  		DetAvgOffline4 = 0;
  	} 
  	else if (( ecdA_PANsave > 0 ) && ( DetAvgOffline4 < 1 )) {
  		DetAvgOffline4++;
  		ecdA_PAN = ecdA_PANsave;
  	}
  	else {
  		ecdA_PAN = ECDOFFLINE;
  		ecdA_PANsave = 0;
  	} {
    V31 &= ~0x2;
    if (!(V31)) {
      { if ( (elecPAN_Fcnt < ELECMAXFAIL ) && (ecdA_PAN == -9999)) VSET_12_(7); }
    }
  }
  }
  {
   	++CUMSEC;
  }
  {
  	if ( MSchanAvg[0] > 0 ) {
  		msdA_0 = msd_sum[0]/MSchanAvg[0];
  		MSchanAvg[0] = msd_sum[0] = 0;
  	} else {
  		msdA_0 = MSDOFFLINE;
  	}
  
  	if ( MSchanAvg[1] > 0 ) {
  		msdA_1 = msd_sum[1]/MSchanAvg[1];
  		MSchanAvg[1] = msd_sum[1] = 0;
  	} else {
  		msdA_1 = MSDOFFLINE;
  	}
  
  	if ( MSchanAvg[2] > 0 ) {
  		msdA_2 = msd_sum[2]/MSchanAvg[2];
  		MSchanAvg[2] = msd_sum[2] = 0;
  	} else {
  		msdA_2 = MSDOFFLINE;
  	}
  
  	if ( MSchanAvg[3] > 0 ) {
  		msdA_3 = msd_sum[3]/MSchanAvg[3];
  		MSchanAvg[3] = msd_sum[3] = 0;
  	} else {
  		msdA_3 = MSDOFFLINE;
  	}
  
  	if ( MSchanAvg[4] > 0 ) {
  		msdA_4 = msd_sum[4]/MSchanAvg[4];
  		MSchanAvg[4] = msd_sum[4] = 0;
  	} else {
  		msdA_4 = MSDOFFLINE;
  	}
  
  	if ( MSchanAvg[5] > 0 ) {
  		msdA_5 = msd_sum[5]/MSchanAvg[5];
  		MSchanAvg[5] = msd_sum[5] = 0;
  	} else {
  		msdA_5 = MSDOFFLINE;
  	}
  
  	if ( MSchanAvg[6] > 0 ) {
  		msdA_6 = msd_sum[6]/MSchanAvg[6];
  		MSchanAvg[6] = msd_sum[6] = 0;
  	} else {
  		msdA_6 = MSDOFFLINE;
  	}
  
  	if ( MSchanAvg[7] > 0 ) {
  		msdA_7 = msd_sum[7]/MSchanAvg[7];
  		MSchanAvg[7] = msd_sum[7] = 0;
  	} else {
  		msdA_7 = MSDOFFLINE;
  	}
  
  }
  {if (!(V7)) {
    { 
    	MSDchromtime += 1; 
    	InjectingInc_MSD = 0;
      }
  }if (!(V8)) {
    { 
    	if ( InjectingInc_MSD == 0 ) {
    		MSDchromtime = 1; 
    		InjectingInc_MSD = 1;
    	} else 
    		MSDchromtime += 1;
      }
  }
  }
  {
  	if (maycomm_proxy != 0)  Trigger ( maycomm_proxy );
  }
  if (!(V22)) {
    {
    		if ( SecCount_1 >= Duration_1 ) VSET_6_(2);
    		else {
    			PressSet_1 += PressINC_1;
    			SecCount_1++;
    			if ( PressSet_1 >= PressMAX_1 ) PressSet_1 = PressMAX_1;
    			SetPress( PressCH_1, PressSet_1, 1 );
    		}
    	}
  }
  if (!(V24)) {
    {
    		if ( SecCount_2 >= Duration_2 ) VSET_7_(2);
    		else {
    			PressSet_2 += PressINC_2;
    			SecCount_2++;
    			if ( PressSet_2 >= PressMAX_2 ) PressSet_2 = PressMAX_2;
    			SetPress( PressCH_2, PressSet_2, 1 );
    		}
    	}
  }
  {
    long int it;
    int subcase;
  
    it = itime();
    ci_settime( it );
    while ( subcase = tma_process( it ) ) {
  	switch (subcase) {
  	  case -1:
  	  case 0: break;
  	  case 1: VSET_4_(1); break;
  	  case 2: VSET_4_(2); break;
  	  case 3: VSET_4_(3); break;
  	  case 4: VSET_5_(1); break;
  	  case 5: VSET_5_(2); break;
  	  case 6: VSET_5_(3); break;
  	  case 7: VSET_6_(1); break;
  	  case 8: VSET_6_(2); break;
  	  case 9: VSET_6_(3); break;
  	  case 10: VSET_6_(4); break;
  	  case 11: VSET_7_(1); break;
  	  case 12: VSET_7_(2); break;
  	  case 13: VSET_7_(3); break;
  	  case 14: VSET_7_(4); break;
  	  case 15: VSET_8_(1); break;
  	  case 16: VSET_8_(2); break;
  	  case 17: VSET_9_(1); break;
  	  case 18: VSET_10_(1); break;
  	  case 19: VSET_11_(1); break;
  	  case 20: VSET_12_(1); break;
  	  case 21: VSET_12_(2); break;
  	  case 22: VSET_12_(3); break;
  	  case 23: VSET_12_(4); break;
  	  case 24: VSET_12_(5); break;
  	  case 25: VSET_12_(6); break;
  	  case 26: VSET_12_(7); break;
  	  case 27: VSET_12_(8); break;
  	  case 28: VSET_13_(1); break;
  	  case 29: VSET_13_(2); break;
  	  case 30: VSET_13_(3); break;
  	  case 31: VSET_13_(4); break;
  	  case 32: VSET_13_(5); break;
  	  case 33: VSET_14_(1); break;
  	  case 34: VSET_14_(2); break;
  	  case 35: VSET_14_(3); break;
  	  case 36: VSET_14_(4); break;
  	  case 37: VSET_14_(5); break;
  	  case 38: VSET_15_(1); break;
  	  case 39: VSET_16_(1); break;
  	  case 40: VSET_17_(1); break;
  	  case 41: VSET_18_(1); break;
  	  case 42: VSET_19_(1); break;
  	  case 43: VSET_20_(1); break;
  	  case 44: VSET_21_(1); break;
  	  default:
  		nl_error( 1, "Unexpected return value from tma_process" );
  		break;
  	}
    }
  }
}

static void EF2_1(void) {
  if (!(V3)) {
    {
    	if (home->U0.GC_Ctr_SF6 >= 0) {
    		ecd_sum1 += home->U0.GC_Ctr_SF6;
    		DetAvgCt1++;
    		ecdSF6x += ELECRATE;
    	} 
    	if (GC_Ctr_F11 >= 0) {
    		ecd_sum2 += GC_Ctr_F11;
    		DetAvgCt2++;
    		ecdF11x += ELECRATE;
    	}
    	if (GC_Ctr_CO >= 0) {
    		ecd_sum3 += GC_Ctr_CO;
    		DetAvgCt3++;
    		ecdCOx += ELECRATE;
    	}
    	if (GC_Ctr_PAN >= 0) {
    		ecd_sum4 += GC_Ctr_PAN;
    		DetAvgCt4++;
    		ecdPANx += ELECRATE;
    	}
    }
  }
  if (!(V12)) {
    {
    
    	if ( GC_Ctr_F11 != ECDOFFLINE ) {
    		integrate( 0, GC_Ctr_F11, F11int, CHROMtime, old_ssvfold );
    	}
    
    	if ( home->U0.GC_Ctr_SF6 != ECDOFFLINE ) {
    		integrate( 0, home->U0.GC_Ctr_SF6, N2Oint, CHROMtime, old_ssv1min );
    	}
    
    	if ( home->U0.GC_Ctr_SF6 != ECDOFFLINE ) {
    		integrate( 0, home->U0.GC_Ctr_SF6, SF6int, CHROMtime, old_ssv1min );
    	}
    
    	if (( GC_Ctr_CO != ECDOFFLINE ) && ( !firsthalf )) {
    		integrate( 0, GC_Ctr_CO, CH4int, CHROMtime, old_ssvfold );
    	}
    
    }
  }
}

static void BF32_5(void) {
  EF2_1();
  home->U25.maycX++;
  {if (!(V9)) {
    { VSET_3_(1); }
  }
  
  	if ( home->U25.maycX >= 120 ) { 
  		home->U25.maycX = 0; VSET_3_(2);
  	}
  }
}

static void BF32_9(void) {
  PresE_SF6 = home->U3.PresE_SF6;
  V10 &= ~0x2;
  EF2_1();
}

static void BF32_11(void) {
  tdlP = home->U23.tdlP;
  tdlsH2O = home->U35.tdlsH2O;
  tdllH2O = home->U35.tdllH2O;
  V10 &= ~0x1;
  EF2_1();
}

static void BF32_13(void) {
  EF2_1();
  if (!(V11)) {
    {
    
    	old_ssvfold = old_ssv1min;
    	old_ssv1min = home->U23.ssv1;
    
    }
  }
}

static void BF32_15(void) {
  EF2_1();
  if (!(V13)) {
    V13 |= 0x1;
    { msg( -2, "Turning Inlet Pump Off (Pres_Inlet = %f)",home->U11.Pres_Inlet ); }
  }
  if (!(V14)) {
    { if (home->U11.Pres_Inlet < PumpON ) VSET_4_(3); }
  }
  if (!(V15)) {
    V15 |= 0x1;
    { msg( -2, "Turning Inlet Pump On (Pres_Inlet = %f)",home->U11.Pres_Inlet ); }
  }
  if (!(V16)) {
    { if (home->U11.Pres_Inlet >= PumpOFF ) VSET_4_(2); }
  }
  if (!(V17)) {
    V17 |= 0x1;
    { msg( -2, "Turning PAN Lamp On (Pres_Inlet = %f)",home->U11.Pres_Inlet ); }
  }
  if (!(V18)) {
    { if (home->U11.Pres_Inlet < PANlampOFF ) VSET_5_(3); }
  }
  if (!(V19)) {
    V19 |= 0x1;
    { msg( -2, "Turning PAN Lamp Off (Pres_Inlet = %f)",home->U11.Pres_Inlet ); }
  }
  if (!(V20)) {
    { if (home->U11.Pres_Inlet > PANlampON ) VSET_5_(2); }
  }
}

static void BF32_17(void) {
  PresL_He = home->U7.PresL_He;
  V25 &= ~0x2;
  EF2_1();
}

static void BF32_19(void) {
  EF2_1();
  if (!(V10)) {
    {
    //	P = ((PresE_SF6) - 30);
        P = (tdlP);
    	home->U33.tdlbH2O = tdllH2O / ( 1.15 - 0.0008123 * P + 5.283e-7 * P*P );
    //	home->U33.tdlbH2O = tdllH2O / ( 1.135 - 0.000757 * P + 5.372e-7 * P*P );
    	home->U33.tdlbH2O = (tdllH2O * 1.62) -2.55;
    	
    	if ( tdllH2O > USELONGPATH ) home->U33.tdlbH2O = (tdlsH2O - OffsetShortPath)*1.55;
    }
  }
  if (!(V25)) {
    {
    		sprintf ( revealMSG, "xPAN:%04.0f,%04.0f", home->U7.PresL_N2, PresL_He );
    		if ( strlen(revealMSG) <= REVEAL_MAXDATA ) 
    			send2reveal( &revealMSG );
    		
    	}
  }
}

static void BF32_23(void) {
  EF2_1();
  { ITXFileNum = home->U0.CurrInj * 1000 + home->U0.CurrFile;
  }
}

static void BF32_25(void) {
  EF2_1();
  if (!(V27)) {
    { if ( home->U0.pilotTrip == 0 ) VSET_12_(8); }
  }
}

static void BF32_27(void) {
  EF2_1();
  if (!(V0)) {
    {
      if ( home->U19.GCstate == 2 ) VSET_0_(3);
    }
  }
    else {
      if ( home->U19.GCstate == 1 ) VSET_0_(2);
      if ( home->U19.GCstate == 0 ) VSET_0_(1);
    }
  {
  		MSDstateS = home->U19.MSDstate;
  	}
  if (!(V6)) {
    {
      if ( home->U19.MSDstate == 2 ) VSET_2_(3);
    }
  }
    else {
      if ( home->U19.MSDstate == 1 ) VSET_2_(2);
      else if ( home->U19.MSDstate == 0 ) VSET_2_(1);
    }
}

static void (*efuncs[64])() = {
  BF32_0,
  EF2_1,
  BF2_0,
  EF2_1,
  BF2_0,
  BF32_5,
  BF2_0,
  EF2_1,
  BF2_0,
  BF32_9,
  BF2_0,
  BF32_11,
  BF2_0,
  BF32_13,
  BF2_0,
  BF32_15,
  BF2_0,
  BF32_17,
  BF2_0,
  BF32_19,
  BF2_0,
  EF2_1,
  BF2_0,
  BF32_23,
  BF2_0,
  BF32_25,
  BF2_0,
  BF32_27,
  BF2_0,
  EF2_1,
  BF2_0,
  EF2_1,
  BF32_0,
  EF2_1,
  BF2_0,
  EF2_1,
  BF2_0,
  BF32_5,
  BF2_0,
  EF2_1,
  BF2_0,
  BF32_9,
  BF2_0,
  BF32_11,
  BF2_0,
  BF32_13,
  BF2_0,
  BF32_15,
  BF2_0,
  BF32_17,
  BF2_0,
  BF32_19,
  BF2_0,
  EF2_1,
  BF2_0,
  BF32_23,
  BF2_0,
  BF32_25,
  BF2_0,
  BF32_27,
  BF2_0,
  EF2_1,
  BF2_0,
  EF2_1
};

static void IVF2_0(void) { {
    V12 |= 0x4;
    V3 |= 0x1;
  }
}
static void IVF32_9(void) {
  V10 |= 0x2;
}
static void IVF32_11(void) {
  V10 |= 0x1;
}
static void IVF32_17(void) {
  V25 |= 0x2;
}
#define IVFUNCS
static void (*ivfuncs[64])() = {
  IVF2_0,
  nullfunc,
  IVF2_0,
  nullfunc,
  IVF2_0,
  nullfunc,
  IVF2_0,
  nullfunc,
  IVF2_0,
  IVF32_9,
  IVF2_0,
  IVF32_11,
  IVF2_0,
  nullfunc,
  IVF2_0,
  nullfunc,
  IVF2_0,
  IVF32_17,
  IVF2_0,
  nullfunc,
  IVF2_0,
  nullfunc,
  IVF2_0,
  nullfunc,
  IVF2_0,
  nullfunc,
  IVF2_0,
  nullfunc,
  IVF2_0,
  nullfunc,
  IVF2_0,
  nullfunc,
  IVF2_0,
  nullfunc,
  IVF2_0,
  nullfunc,
  IVF2_0,
  nullfunc,
  IVF2_0,
  nullfunc,
  IVF2_0,
  IVF32_9,
  IVF2_0,
  IVF32_11,
  IVF2_0,
  nullfunc,
  IVF2_0,
  nullfunc,
  IVF2_0,
  IVF32_17,
  IVF2_0,
  nullfunc,
  IVF2_0,
  nullfunc,
  IVF2_0,
  nullfunc,
  IVF2_0,
  nullfunc,
  IVF2_0,
  nullfunc,
  IVF2_0,
  nullfunc,
  IVF2_0,
  nullfunc
};

static void nullfunc(void){}
#define TRN 320
#define TRD 1
#define LOWLIM (-2880)
#define HIGHLIM (2880)
#define NBROW 48
#define NROWMINF 1
#define NSECSPER 1
#define NROWSPER 32
#define SYNCHVAL 0xABB4
#define NROWMAJF 64
#define MFSECNUM 32
#define MFSECDEN 1
#define SECDRIFT 90
#define COPY_MFCtr
#define MFCtr home->U0.MFCtr

#ifndef EXTRACTION_INIT
  #define EXTRACTION_INIT
#endif
#ifndef OPT_EXT_INIT
  #define OPT_EXT_INIT
#endif
#ifndef EXTRACTION_TERM
  #define EXTRACTION_TERM
#endif
#ifndef TMINITFUNC
  #define TMINITFUNC
#endif

static unsigned int next_minor_frame, majf_row;
#if (NROWMINF != 1)
  static unsigned int minf_row = 0;
#endif
#ifdef NEED_TIME_FUNCS
  static unsigned short CurMFC;
#endif


void main(int argc, char **argv) {
  oui_init_options(argc, argv);

  TMINITFUNC;
  BEGIN_MSG;
  EXTRACTION_INIT;
  DC_operate();
  EXTRACTION_TERM;
  DONE_MSG;
}


#define MKDCTV(x,y) ((x<<8)|y)
#define DCTV(x,y) MKDCTV(DCT_##x,DCV_##y)

/* The main thing we need to do is reset our row counter on TM START */
void DC_DASCmd(unsigned char type, unsigned char val) {
  switch (MKDCTV(type, val)) {
	case DCTV(TM,TM_START):
	  next_minor_frame = majf_row = 0;
	  #if (NROWMINF != 1)
		minf_row = 0;
	  #endif
	  break;
	case DCTV(TM,TM_END):
	case DCTV(QUIT,QUIT):
	default:
	  break;
  }
}

#define incmod(x,y) if (x==((y)-1)) x = 0; else x++

void DC_data(dbr_data_type *dr_data) {
  unsigned short nrows;

  for (nrows = dr_data->n_rows, home = (void *) &dr_data->data[0];
	   nrows > 0;
	   nrows--, home ++) {

	/* First check the minor frame counter if necessary */
	#if (NROWMINF != 1)
	if (minf_row == 0) {
	#endif
	  COPY_MFCtr /* Needs to be defined by TMC */
	  #ifdef NEED_TIME_FUNCS
		CurMFC = MFCtr;
	  #endif
	  {
		unsigned short delta;
		
		delta = MFCtr - next_minor_frame;
		if (delta != 0) {
		  #ifdef IVFUNCS
			if (delta > NROWMAJF/NROWMINF) delta = NROWMAJF;
			else delta *= NROWMINF;
			/* delta is now the number of rows skipped up to a maximum of
			  nrowmajf. While invalidating, I don't need to update
			  minf_row, since the final will be 0, same as before.
			  MFCtr is already set, and majf_row is updated.
			*/
			while (delta-- > 0)
			  ivfuncs[majf_row]();
		  #endif
		  majf_row = (((unsigned short)MFCtr) % (NROWMAJF/NROWMINF))
							  * NROWMINF;
		}
	  }
	  next_minor_frame = MFCtr+1;
	#if (NROWMINF != 1)
	}
	#endif
	
	/* Now process the row */
	efuncs[majf_row]();
	incmod(majf_row, NROWMAJF);
	#if (NROWMINF != 1)
	  incmod(minf_row, NROWMINF);
	#endif
  }
}

#ifdef __WATCOMC__
  #pragma off (unreferenced)
#endif

void DC_tstamp(tstamp_type *tstamp) { /* Nothing to do! */ }

void DC_other(unsigned char *msg_ptr, int sent_tid) {
  unsigned char rep_msg = DAS_UNKN;

  Reply(sent_tid, &rep_msg, 1);
}

#ifdef __WATCOMC__
  #pragma on (unreferenced)
#endif

#ifdef NEED_TIME_FUNCS
  #if (NROWMINF != 1)
	#define ROWS(x) (((unsigned long)(x))*NROWMINF+minf_row)
  #else
	#define ROWS(x) (x)
  #endif
  #if (NSECSPER != 1)
	#define FRACSECS(x) (((unsigned long)ROWS(x))*NSECSPER)
  #else
	#define FRACSECS(x) ROWS(x)
  #endif
  long itime(void) {
	  return(dbr_info.t_stmp.secs +
		FRACSECS(CurMFC-dbr_info.t_stmp.mfc_num)
	#if (NROWSPER != 1)
		  / NROWSPER
	#endif
		  );
  }
  double dtime(void) {
	  return(dbr_info.t_stmp.secs +
		(double) FRACSECS(CurMFC-dbr_info.t_stmp.mfc_num)
	#if (NROWSPER != 1)
		  / NROWSPER
	#endif
		  );
  }
  double etime(void) {
	double t;
	static double t0 = -1e9;
	
	t = dtime();
	if (t0 == -1e9) t0 = t;
	return(t - t0);
  }
#endif

dbr_info_type dbr_info = {
  "", /* tmid */
  48, /* NBMINF */
  48, /* NBROW */
  64, /* NROWSMAJF */
  1, /* NSECSPER */
  32, /* NROWSPER */
  0, 1, /* MFC lsb col, msb col */
  0xABB4, /* Synch Value */
  0 /* not inverted */
};
